Subject: Problems using in.telnetd under Solaris 2.5.1 under netacl

From: "K.Dreher" <[email-masked]>
Date: Tue, 6 Jun 2000 13:11:55 +0200

[To be removed from this list send the message "unsubscribe fwtk-users" in the
BODY of a mail message to [email-masked].]

Hi,

I had send the following mail to the fwtk-users list without response.

|| From dreher Mon Jun  5 13:09:58 2000
|| To: [email-masked]
|| Subject: Problems using in.telnetd under Solaris 2.5.1 under netacl
|| Mime-Version: 1.0
|| Content-Transfer-Encoding: 7bit
|| Content-MD5: 8rEY1p/UBzRgEY5xs+m6Jg==
|| 
|| Hi,
|| 
|| using standard telnetd from Solaris 2.5.1 under netacl I am not able to enter 
|| the name of the name/password pair. The request is timed and a new name is requested from telnet.
|| The same telnetd under inetd is working properly.
|| 
|| 
|| Configuration:
|| 
|| fwtk:		2.1
|| OS:		Solaris 2.5.1 Sparc
|| netperm-table:	netacl-telnet: permit-hosts *  -exec /usr/sbin/in.telnetd
|| ps -ef:		root  9215     1  0 11:38:14 ?        0:00 /opt/fwtk/netacl -daemon 23 telnet
|| inetd.conf:	# telnet        stream  tcp     nowait  root    /usr/sbin/in.telnetd    in.telnetd
|| 
|| log:		kd:/mnt/dreher[1] telnet kd
|| 		Trying 141.5.196.11...
|| 		Connected to kd.
|| 		Escape character is '^]'.
|| 
|| 
|| 		UNIX(r) System V Release 4.0 (kd)
|| 
|| 		login: dreher		<< no CR accepted !!
|| 		Login incorrect
|| 		login: ^CConnection closed by foreign host.
|| 		kd:/mnt/dreher[2]
|| 		
|| Any idea out there?
|| 
||- Klaus
|| 
|| 
|| __
|| 
|| K|| laus Dreher
|| Max Planck Institut
||     fuer molekulare Physiologie
|| Otto Hahn Strasse 11
|| D 44227 Dortmund
|| Tel. +49 (0)231 133 2671
|| Fax: +49 (0)231 133 1006
|| Mail: [email-masked]

In addition I have "trussed" inetd and netacl and I have found, that /bin/login called by
/usr/sbin/in.telnetd needs /dev/tty to reopen the inputchannel for the password. Under netacl
/dev/tty does not exist, so the password is not recognised.

truss inetd:

 getmsg(5, 0xEFFFE2F0, 0x0002CC48, 0xEFFFE33C)   = 0
7238:   lseek(3, 0, SEEK_CUR)                           = 0
7238:   close(3)                                        = 0	<<<<<<<<< close
7238:   munmap(0xEF563000, 2308)                        = 0
7238:   munmap(0xEF550000, 13374)                       = 0
7238:   munmap(0xEF543000, 4324)                        = 0
7238:   munmap(0xEF530000, 15086)                       = 0
7238:   open("/dev/tty", O_RDONLY)                      = 3     <<<<<<<<< reopen
7238:   sigaction(SIGINT, 0xEFFFE598, 0xEFFFE698)       = 0
7238:   ioctl(3, TCGETA, 0xEFFFE73C)                    = 0
7238:   ioctl(3, TCSETAF, 0xEFFFE73C)                   = 0
7238:   write(2, " P a s s w o r d :  ", 10)            = 10
7238:   read(3, 0xEF653704, 1)          (sleeping...)
7238:   read(3, " $", 1)                                = 1
7238:   read(3, " $", 1)                                = 1
7238:   read(3, " J", 1)                                = 1
7238:   read(3, " A", 1)                                = 1

truss netacl:

poll(0x00031B14, 1, 15000)                      = 1
6555:   getmsg(5, 0xEFFFE310, 0x0002CC48, 0xEFFFE35C)   = 0
6555:   lseek(3, 0, SEEK_CUR)                           = 0
6555:   close(3)                                        = 0     <<<<<<<<< close
6555:   munmap(0xEF563000, 2308)                        = 0
6555:   munmap(0xEF550000, 13374)                       = 0
6555:   munmap(0xEF543000, 4324)                        = 0
6555:   munmap(0xEF530000, 15086)                       = 0
6555:   open("/dev/tty", O_RDONLY)                      Err#6 ENXIO <<<<<< !!!!!!!
6555:   alarm(0)                                        = 298
6555:   sigaction(SIGALRM, 0xEFFFE748, 0xEFFFE7F8)      = 0
6555:   sigprocmask(SIG_BLOCK, 0xEFFFE7E8, 0xEFFFE7D8)  = 0
6555:   alarm(4)                                        = 0
6555:   sigsuspend(0xEFFFE7C8)          (sleeping...)
6555:       Received signal #14, SIGALRM, in sigsuspend() [caught]
6555:   sigsuspend(0xEFFFE7C8)                          Err#4 EINTR
6555:   setcontext(0xEFFFE5A8)
6555:   alarm(0)                                        = 0

Is there anyone using netacl in conjuction with in.telnetd 
under Solaris??

		Klaus Dreher

__

Klaus Dreher
Max Planck Institut
    fuer molekulare Physiologie
Otto Hahn Strasse 11
D 44227 Dortmund
Tel. +49 (0)231 133 2671
Fax: +49 (0)231 133 1006
Mail: [email-masked]